summaryrefslogtreecommitdiff
path: root/test
diff options
context:
space:
mode:
authorHarald Hoyer <harald@redhat.com>2012-05-25 18:32:55 +0200
committerHarald Hoyer <harald@redhat.com>2012-05-29 09:23:37 +0200
commit0d6e798a784ef0ba6b95512e4453067b2f84a91a (patch)
tree6f825d8cae6e431599f2490dae0ab188a2a37370 /test
parent1ecf6a2b4960229ad1d06c591b4776ddf065e834 (diff)
test/TEST-01-BASIC: add /var on cryptoluks and wait for the journal
Diffstat (limited to 'test')
-rwxr-xr-xtest/TEST-01-BASIC/test.sh114
-rw-r--r--test/test-functions246
2 files changed, 320 insertions, 40 deletions
diff --git a/test/TEST-01-BASIC/test.sh b/test/TEST-01-BASIC/test.sh
index efdf449a8..d50c835e5 100755
--- a/test/TEST-01-BASIC/test.sh
+++ b/test/TEST-01-BASIC/test.sh
@@ -4,26 +4,31 @@
TEST_DESCRIPTION="Basic systemd setup"
KVERSION=${KVERSION-$(uname -r)}
+KERNEL_VER=$(uname -r)
# Uncomment this to debug failures
#DEBUGFAIL="systemd.unit=multi-user.target"
DEBUGTOOLS="df free ls stty cat ps ln ip route dmesg dhclient mkdir cp ping dhclient strace less grep id tty touch du sort"
-
run_qemu() {
+ # TODO: qemu wrapper script: http://www.spinics.net/lists/kvm/msg72389.html
qemu-kvm \
-hda $TESTDIR/rootdisk.img \
- -m 256M -nographic \
- -net none -kernel /boot/vmlinuz-$KVERSION \
- -append "root=/dev/sda1 systemd.log_level=debug raid=noautodetect loglevel=2 init=/usr/lib/systemd/systemd rw console=ttyS0,115200n81 selinux=0 $DEBUGFAIL" || return 1
+ -m 512M -nographic \
+ -net none -kernel /boot/vmlinuz-$KERNEL_VER \
+ -append "root=/dev/sda1 systemd.log_level=debug raid=noautodetect loglevel=2 init=/usr/lib/systemd/systemd ro console=ttyS0,115200n81 selinux=0 $DEBUGFAIL" || return 1
ret=1
mkdir -p $TESTDIR/root
mount ${LOOPDEV}p1 $TESTDIR/root
[[ -e $TESTDIR/root/testok ]] && ret=0
- cp -a $TESTDIR/root/var/log/journal $TESTDIR
cp -a $TESTDIR/root/failed $TESTDIR
+ cryptsetup luksOpen ${LOOPDEV}p2 varcrypt <$TESTDIR/keyfile
+ mount /dev/mapper/varcrypt $TESTDIR/root/var
+ cp -a $TESTDIR/root/var/log/journal $TESTDIR
+ umount $TESTDIR/root/var
umount $TESTDIR/root
+ cryptsetup luksClose /dev/mapper/varcrypt
cat $TESTDIR/failed
ls -l $TESTDIR/journal/*/*.journal
test -s $TESTDIR/failed && ret=$(($ret+1))
@@ -45,9 +50,16 @@ run_nspawn() {
test_run() {
- run_qemu || return 1
- if [[ -d /sys/fs/cgroup/systemd ]]; then
- run_nspawn || return 1
+ if check_qemu ; then
+ run_qemu || return 1
+ else
+ dwarn "can't run qemu-kvm, skipping"
+ fi
+ if check_nspawn; then
+#run_nspawn || return 1
+ :
+ else
+ dwarn "can't run systemd-nspawn, skipping"
fi
return 0
}
@@ -55,20 +67,26 @@ test_run() {
test_setup() {
rm -f $TESTDIR/rootdisk.img
# Create the blank file to use as a root filesystem
- dd if=/dev/null of=$TESTDIR/rootdisk.img bs=1M seek=100
+ dd if=/dev/null of=$TESTDIR/rootdisk.img bs=1M seek=200
LOOPDEV=$(losetup --show -P -f $TESTDIR/rootdisk.img)
[ -b $LOOPDEV ] || return 1
echo "LOOPDEV=$LOOPDEV" >> $STATEFILE
- sfdisk -C 3200 -H 2 -S 32 -L $LOOPDEV <<EOF
+ sfdisk -C 6400 -H 2 -S 32 -L $LOOPDEV <<EOF
+,3200
,
EOF
mkfs.ext3 -L systemd ${LOOPDEV}p1
+ echo -n test >$TESTDIR/keyfile
+ cryptsetup -q luksFormat ${LOOPDEV}p2 $TESTDIR/keyfile
+ cryptsetup luksOpen ${LOOPDEV}p2 varcrypt <$TESTDIR/keyfile
+ mkfs.ext3 -L var /dev/mapper/varcrypt
mkdir -p $TESTDIR/root
mount ${LOOPDEV}p1 $TESTDIR/root
mkdir -p $TESTDIR/root/run
+ mkdir -p $TESTDIR/root/var
+ mount /dev/mapper/varcrypt $TESTDIR/root/var
- kernel=$KVERSION
# Create what will eventually be our root filesystem onto an overlay
(
LOG_LEVEL=5
@@ -80,6 +98,9 @@ EOF
# install compiled files
(cd ../..; make DESTDIR=$initdir install)
+ # remove unneeded documentation
+ rm -fr $initdir/usr/share/{man,doc,gtk-doc}
+
# install possible missing libraries
for i in $initdir/{sbin,bin}/* $initdir/lib/systemd/*; do
inst_libs $i
@@ -104,10 +125,25 @@ EOF
inst /etc/localtime
# we want an empty environment
> $initdir/etc/environment
+ > $initdir/etc/machine-id
# set the hostname
echo systemd-testsuite > $initdir/etc/hostname
+ eval $(udevadm info --export --query=env --name=/dev/mapper/varcrypt)
+ eval $(udevadm info --export --query=env --name=${LOOPDEV}p2)
+
+ cat >$initdir/etc/crypttab <<EOF
+$DM_NAME UUID=$ID_FS_UUID /etc/varkey
+EOF
+ echo -n test > $initdir/etc/varkey
+ cat $initdir/etc/crypttab | ddebug
+
+ cat >$initdir/etc/fstab <<EOF
+LABEL=systemd / ext3 rw 0 1
+/dev/mapper/varcrypt /var ext3 defaults 0 1
+EOF
+
# setup the testsuite target
cat >$initdir/etc/systemd/system/testsuite.target <<EOF
[Unit]
@@ -125,10 +161,9 @@ Description=Testsuite service
After=multi-user.target
[Service]
-ExecStart=/bin/sh -c 'systemctl --failed --no-legend --no-pager > /failed ; echo OK > /testok'
-ExecStartPost=/usr/sbin/poweroff
+ExecStart=/bin/bash -c 'set -x; systemctl --failed --no-legend --no-pager > /failed ; echo OK > /testok; while : ;do systemd-cat echo "testsuite service waiting for /var/log/journal" ; echo "testsuite service waiting for journal to move to /var/log/journal" > /dev/console ; for i in /var/log/journal/*;do [ -d "\$i" ] && echo "\$i" && break 2; done; sleep 1; done; sleep 1; exit 0;'
+ExecStopPost=/usr/bin/systemctl poweroff
Type=oneshot
-
EOF
mkdir -p $initdir/etc/systemd/system/testsuite.target.wants
ln -fs ../testsuite.service $initdir/etc/systemd/system/testsuite.target.wants/testsuite.service
@@ -143,7 +178,16 @@ EOF
chmod 0755 $initdir/etc/rc.d/rc.local
# install basic tools needed
dracut_install sh bash setsid loadkeys setfont \
- login sushell sulogin gzip sleep echo
+ login sushell sulogin gzip sleep echo mount umount cryptsetup
+ dracut_install dmsetup modprobe
+
+ instmods dm_crypt =crypto
+
+ type -P dmeventd >/dev/null && dracut_install dmeventd
+
+ inst_libdir_file "libdevmapper-event.so*"
+
+ inst_rules 10-dm.rules 13-dm-disk.rules 95-dm-notify.rules
# install libnss_files for login
inst_libdir_file "libnss_files*"
@@ -190,13 +234,13 @@ EOF
done
# install plymouth, if found... else remove plymouth service files
- if [ -x /usr/libexec/plymouth/plymouth-populate-initrd ]; then
- PLYMOUTH_POPULATE_SOURCE_FUNCTIONS="$TEST_BASE_DIR/test-functions" \
- /usr/libexec/plymouth/plymouth-populate-initrd -t $initdir
- dracut_install plymouth plymouthd
- else
- rm -f $initdir/usr/lib/systemd/system/plymouth* $initdir/usr/lib/systemd/system/*/plymouth*
- fi
+ # if [ -x /usr/libexec/plymouth/plymouth-populate-initrd ]; then
+ # PLYMOUTH_POPULATE_SOURCE_FUNCTIONS="$TEST_BASE_DIR/test-functions" \
+ # /usr/libexec/plymouth/plymouth-populate-initrd -t $initdir
+ # dracut_install plymouth plymouthd
+ # else
+ rm -f $initdir/{usr/lib,etc}/systemd/system/plymouth* $initdir/{usr/lib,etc}/systemd/system/*/plymouth*
+ # fi
# some helper tools for debugging
[[ $DEBUGTOOLS ]] && dracut_install $DEBUGTOOLS
@@ -204,15 +248,35 @@ EOF
# install ld.so.conf* and run ldconfig
cp -a /etc/ld.so.conf* $initdir/etc
ldconfig -r "$initdir"
-
+ ddebug "Strip binaeries"
+ find "$initdir" -perm +111 -type f | xargs strip --strip-unneeded | ddebug
+
+ # copy depmod files
+ inst /lib/modules/$KERNEL_VER/modules.order
+ inst /lib/modules/$KERNEL_VER/modules.builtin
+ # generate module dependencies
+ if [[ -d $initdir/lib/modules/$KERNEL_VER ]] && \
+ ! depmod -a -b "$initdir" $KERNEL_VER; then
+ dfatal "\"depmod -a $KERNEL_VER\" failed."
+ exit 1
+ fi
)
rm -fr $TESTDIR/nspawn-root
- cp -avr $TESTDIR/root $TESTDIR/nspawn-root
-
+ ddebug "cp -ar $TESTDIR/root $TESTDIR/nspawn-root"
+ cp -ar $TESTDIR/root $TESTDIR/nspawn-root
+ # we don't mount in the nspawn root
+ rm -fr $TESTDIR/nspawn-root/etc/fstab
+
+ ddebug "umount $TESTDIR/root/var"
+ umount $TESTDIR/root/var
+ cryptsetup luksClose /dev/mapper/varcrypt
+ ddebug "umount $TESTDIR/root"
umount $TESTDIR/root
}
test_cleanup() {
+ umount $TESTDIR/root/var 2>/dev/null
+ [[ -b /dev/mapper/varcrypt ]] && cryptsetup luksClose /dev/mapper/varcrypt
umount $TESTDIR/root 2>/dev/null
[[ $LOOPDEV ]] && losetup -d $LOOPDEV
return 0
diff --git a/test/test-functions b/test/test-functions
index 5fdf0a18b..c35542319 100644
--- a/test/test-functions
+++ b/test/test-functions
@@ -4,21 +4,15 @@
PATH=/sbin:/bin:/usr/sbin:/usr/bin
export PATH
-setup_basic_dirs() {
- for d in usr/bin usr/sbin bin etc lib "$libdir" sbin tmp usr var var/log; do
- [[ -e "${initdir}${prefix}/$d" ]] && continue
- if [ -L "/$d" ]; then
- inst_symlink "/$d" "${prefix}/$d"
- else
- mkdir -m 0755 -p "${initdir}${prefix}/$d"
- fi
- done
+KERNEL_VER=${KERNEL_VER-$(uname -r)}
+KERNEL_MODS="/lib/modules/$KERNEL_VER/"
- for d in dev proc sys sysroot root run run/lock run/initramfs; do
+setup_basic_dirs() {
+ for d in usr/bin usr/sbin bin etc lib "$libdir" sbin tmp usr var var/log dev proc sys sysroot root run run/lock run/initramfs; do
if [ -L "/$d" ]; then
inst_symlink "/$d"
else
- mkdir -m 0755 -p "$initdir/$d"
+ inst_dir "/$d"
fi
done
@@ -127,9 +121,9 @@ dtrace() {
# @param msg Message.
# @retval 0 It's always returned, even if logging failed.
ddebug() {
- set +x
+# set +x
dlog 5 "$@"
- [ -n "$debug" ] && set -x || :
+# [ -n "$debug" ] && set -x || :
}
## @brief Logs message at INFO level (4)
@@ -157,9 +151,9 @@ dwarn() {
# @param msg Message.
# @retval 0 It's always returned, even if logging failed.
derror() {
- set +x
+# set +x
dlog 2 "$@"
- [ -n "$debug" ] && set -x || :
+# [ -n "$debug" ] && set -x || :
}
## @brief Logs message at FATAL level (1)
@@ -547,6 +541,228 @@ dracut_install() {
done
}
+# Install a single kernel module along with any firmware it may require.
+# $1 = full path to kernel module to install
+install_kmod_with_fw() {
+ # no need to go further if the module is already installed
+
+ [[ -e "${initdir}/lib/modules/$KERNEL_VER/${1##*/lib/modules/$KERNEL_VER/}" ]] \
+ && return 0
+
+ [[ -e "$initdir/.kernelmodseen/${1##*/}" ]] && return 0
+
+ if [[ $omit_drivers ]]; then
+ local _kmod=${1##*/}
+ _kmod=${_kmod%.ko}
+ _kmod=${_kmod/-/_}
+ if [[ "$_kmod" =~ $omit_drivers ]]; then
+ dinfo "Omitting driver $_kmod"
+ return 1
+ fi
+ if [[ "${1##*/lib/modules/$KERNEL_VER/}" =~ $omit_drivers ]]; then
+ dinfo "Omitting driver $_kmod"
+ return 1
+ fi
+ fi
+
+ [ -d "$initdir/.kernelmodseen" ] && \
+ > "$initdir/.kernelmodseen/${1##*/}"
+
+ inst_simple "$1" "/lib/modules/$KERNEL_VER/${1##*/lib/modules/$KERNEL_VER/}" \
+ || return $?
+
+ local _modname=${1##*/} _fwdir _found _fw
+ _modname=${_modname%.ko*}
+ for _fw in $(modinfo -k $KERNEL_VER -F firmware $1 2>/dev/null); do
+ _found=''
+ for _fwdir in $fw_dir; do
+ if [[ -d $_fwdir && -f $_fwdir/$_fw ]]; then
+ inst_simple "$_fwdir/$_fw" "/lib/firmware/$_fw"
+ _found=yes
+ fi
+ done
+ if [[ $_found != yes ]]; then
+ if ! grep -qe "\<${_modname//-/_}\>" /proc/modules; then
+ dinfo "Possible missing firmware \"${_fw}\" for kernel module" \
+ "\"${_modname}.ko\""
+ else
+ dwarn "Possible missing firmware \"${_fw}\" for kernel module" \
+ "\"${_modname}.ko\""
+ fi
+ fi
+ done
+ return 0
+}
+
+# Do something with all the dependencies of a kernel module.
+# Note that kernel modules depend on themselves using the technique we use
+# $1 = function to call for each dependency we find
+# It will be passed the full path to the found kernel module
+# $2 = module to get dependencies for
+# rest of args = arguments to modprobe
+# _fderr specifies FD passed from surrounding scope
+for_each_kmod_dep() {
+ local _func=$1 _kmod=$2 _cmd _modpath _options _found=0
+ shift 2
+ modprobe "$@" --ignore-install --show-depends $_kmod 2>&${_fderr} | (
+ while read _cmd _modpath _options; do
+ [[ $_cmd = insmod ]] || continue
+ $_func ${_modpath} || exit $?
+ _found=1
+ done
+ [[ $_found -eq 0 ]] && exit 1
+ exit 0
+ )
+}
+
+# filter kernel modules to install certain modules that meet specific
+# requirements.
+# $1 = search only in subdirectory of /kernel/$1
+# $2 = function to call with module name to filter.
+# This function will be passed the full path to the module to test.
+# The behaviour of this function can vary depending on whether $hostonly is set.
+# If it is, we will only look at modules that are already in memory.
+# If it is not, we will look at all kernel modules
+# This function returns the full filenames of modules that match $1
+filter_kernel_modules_by_path () (
+ local _modname _filtercmd
+ if ! [[ $hostonly ]]; then
+ _filtercmd='find "$KERNEL_MODS/kernel/$1" "$KERNEL_MODS/extra"'
+ _filtercmd+=' "$KERNEL_MODS/weak-updates" -name "*.ko" -o -name "*.ko.gz"'
+ _filtercmd+=' -o -name "*.ko.xz"'
+ _filtercmd+=' 2>/dev/null'
+ else
+ _filtercmd='cut -d " " -f 1 </proc/modules|xargs modinfo -F filename '
+ _filtercmd+='-k $KERNEL_VER 2>/dev/null'
+ fi
+ for _modname in $(eval $_filtercmd); do
+ case $_modname in
+ *.ko) "$2" "$_modname" && echo "$_modname";;
+ *.ko.gz) gzip -dc "$_modname" > $initdir/$$.ko
+ $2 $initdir/$$.ko && echo "$_modname"
+ rm -f $initdir/$$.ko
+ ;;
+ *.ko.xz) xz -dc "$_modname" > $initdir/$$.ko
+ $2 $initdir/$$.ko && echo "$_modname"
+ rm -f $initdir/$$.ko
+ ;;
+ esac
+ done
+)
+find_kernel_modules_by_path () (
+ if ! [[ $hostonly ]]; then
+ find "$KERNEL_MODS/kernel/$1" "$KERNEL_MODS/extra" "$KERNEL_MODS/weak-updates" \
+ -name "*.ko" -o -name "*.ko.gz" -o -name "*.ko.xz" 2>/dev/null
+ else
+ cut -d " " -f 1 </proc/modules \
+ | xargs modinfo -F filename -k $KERNEL_VER 2>/dev/null
+ fi
+)
+
+filter_kernel_modules () {
+ filter_kernel_modules_by_path drivers "$1"
+}
+
+find_kernel_modules () {
+ find_kernel_modules_by_path drivers
+}
+
+# instmods [-c] <kernel module> [<kernel module> ... ]
+# instmods [-c] <kernel subsystem>
+# install kernel modules along with all their dependencies.
+# <kernel subsystem> can be e.g. "=block" or "=drivers/usb/storage"
+instmods() {
+ [[ $no_kernel = yes ]] && return
+ # called [sub]functions inherit _fderr
+ local _fderr=9
+ local _check=no
+ if [[ $1 = '-c' ]]; then
+ _check=yes
+ shift
+ fi
+
+ function inst1mod() {
+ local _ret=0 _mod="$1"
+ case $_mod in
+ =*)
+ if [ -f $KERNEL_MODS/modules.${_mod#=} ]; then
+ ( [[ "$_mpargs" ]] && echo $_mpargs
+ cat "${KERNEL_MODS}/modules.${_mod#=}" ) \
+ | instmods
+ else
+ ( [[ "$_mpargs" ]] && echo $_mpargs
+ find "$KERNEL_MODS" -path "*/${_mod#=}/*" -printf '%f\n' ) \
+ | instmods
+ fi
+ ;;
+ --*) _mpargs+=" $_mod" ;;
+ i2o_scsi) return ;; # Do not load this diagnostic-only module
+ *)
+ _mod=${_mod##*/}
+ # if we are already installed, skip this module and go on
+ # to the next one.
+ [[ -f "$initdir/.kernelmodseen/${_mod%.ko}.ko" ]] && return
+
+ if [[ $omit_drivers ]] && [[ "$1" =~ $omit_drivers ]]; then
+ dinfo "Omitting driver ${_mod##$KERNEL_MODS}"
+ return
+ fi
+ # If we are building a host-specific initramfs and this
+ # module is not already loaded, move on to the next one.
+ [[ $hostonly ]] && ! grep -qe "\<${_mod//-/_}\>" /proc/modules \
+ && ! echo $add_drivers | grep -qe "\<${_mod}\>" \
+ && return
+
+ # We use '-d' option in modprobe only if modules prefix path
+ # differs from default '/'. This allows us to use Dracut with
+ # old version of modprobe which doesn't have '-d' option.
+ local _moddirname=${KERNEL_MODS%%/lib/modules/*}
+ [[ -n ${_moddirname} ]] && _moddirname="-d ${_moddirname}/"
+
+ # ok, load the module, all its dependencies, and any firmware
+ # it may require
+ for_each_kmod_dep install_kmod_with_fw $_mod \
+ --set-version $KERNEL_VER ${_moddirname} $_mpargs
+ ((_ret+=$?))
+ ;;
+ esac
+ return $_ret
+ }
+
+ function instmods_1() {
+ local _mod _mpargs
+ if (($# == 0)); then # filenames from stdin
+ while read _mod; do
+ inst1mod "${_mod%.ko*}" || {
+ if [ "$_check" = "yes" ]; then
+ dfatal "Failed to install $_mod"
+ return 1
+ fi
+ }
+ done
+ fi
+ while (($# > 0)); do # filenames as arguments
+ inst1mod ${1%.ko*} || {
+ if [ "$_check" = "yes" ]; then
+ dfatal "Failed to install $1"
+ return 1
+ fi
+ }
+ shift
+ done
+ return 0
+ }
+
+ local _ret _filter_not_found='FATAL: Module .* not found.'
+ set -o pipefail
+ # Capture all stderr from modprobe to _fderr. We could use {var}>...
+ # redirections, but that would make dracut require bash4 at least.
+ eval "( instmods_1 \"\$@\" ) ${_fderr}>&1" \
+ | while read line; do [[ "$line" =~ $_filter_not_found ]] && echo $line || echo $line >&2 ;done | derror
+ _ret=$?
+ set +o pipefail
+ return $_ret
+}
# inst_libdir_file [-n <pattern>] <file> [<file>...]
# Install a <file> located on a lib directory to the initramfs image